# List Responses

> Source: https://truto.one/docs/api-reference/unified-forms-api/responses/list/

`GET /unified/forms/responses`

Resource: **Responses** · API: **Unified Forms API**

## Supported integrations

Google, Google Forms, Jotform, Survey Monkey (partial), SurveySparrow, Typeform, Webflow

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_key_by`** _(string)_
  By default the `result` attribute is an array of objects. This parameter allows you to specify a field in each `result` objects to use as key, which transforms the `result` array into an object with the array items keyed by the field. This is useful for when you want to use the result as a lookup table.
- **`truto_ignore_limit`** _(boolean)_
  Ignores the `limit` query parameter.
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`form`** _(object)_
  The form to which the response belongs.
- **`updated_at`** _(string)_
  The date and time when the response was last updated.
- **`created_at`** _(string)_
  The date and time when the response was created.
- **`sort_by`** _(enum)_
  Allowed: `created_at`, `updated_at`

## Response body

- **`result`** _(array<object>)_
  List of Responses
  - **`id`** _(string)_
    The unique identifier of the response.
  - **`name`** _(string)_
    The name of the response.
  - **`status`** _(string)_
    The status of the form response.
    Allowed: `initiated`, `completed`, `submitted`
  - **`answers`** _(array<object>)_
    The answers submitted
    - **`field`** _(object)_
      - **`id`** _(string)_
        The field's unique identifier.
      - **`name`** _(string)_
        The field's name.
      - **`label`** _(string)_
        The field's label.
      - **`type`** _(string)_
        The field's type. If no clear mapping exists, then raw value is returned.
        Allowed: `statement`, `string`, `text`, `rich_text`, `number`, `boolean`, `date`, `datetime`, `time`, `enum`, `array`, `file` (+5 more)
      - **`field_group`** _(object)_
        The field's group identifier. If present, the field is part of a group.
    - **`value`** _(string)_
      The value for the field submitted
  - **`created_by`** _(object)_
    User who created the response.
    - **`id`** _(string)_
      The unique identifier for a user
    - **`name`** _(string)_
      The name of the user
  - **`form`** _(object)_
    The form to which the response belongs.
    - **`id`** _(string)_
      The unique identifier of the form.
    - **`name`** _(string)_
      The name of the form.
  - **`workspace`** _(object)_
    The workspace to which the response belongs.
    - **`id`** _(string)_
      The unique identifier of the workspace.
    - **`name`** _(string)_
      The name of the workspace.
  - **`organization`** _(object)_
    The organization to which the response belongs.
    - **`id`** _(string)_
      The unique identifier of the organization.
    - **`name`** _(string)_
      The name of the organization.
  - **`opened_at`** _(string)_
    The date and time when the form was opened.
  - **`created_at`** _(string)_
    The date and time when the response was created.
  - **`updated_at`** _(string)_
    The date and time when the response was last updated.
  - **`remote_data`** _(object)_
    Raw data returned from the remote API call.
- **`next_cursor`** _(string)_
  The cursor to use for the next page of results. Pass this value as `next_cursor` in the query parameter in the next request to get the next page of results.

## Code examples

### curl

```bash
curl -X GET 'https://api.truto.one/unified/forms/responses?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const response = await fetch(`https://api.truto.one/unified/forms/responses?integrated_account_id=${integratedAccountId}`, {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/forms/responses"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}

response = requests.get(url, headers=headers, params=params)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.list(
  'forms',
  'responses',
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    async for item in truto_api.unified_api.list(
        "forms",
        "responses",
        {"integrated_account_id": "<integrated_account_id>"}
    ):
        print(item)

asyncio.run(main())
```
